\version "2.20.0"

% Add empty text to note so it can be modified to soloText/soloIIText
#(define (textScript event property)
  (set! (ly:music-property event property)
        (append
          (ly:music-property event property)
          `(,(make-music 'TextScriptEvent 'text "")))))

addText =
#(define-music-function (music) (ly:music?)
  (map-some-music
    (lambda (m)
      (case (ly:music-property m 'name)
        ((NoteEvent)  (textScript m 'articulations) m)
        ((EventChord) (textScript m 'elements)      m)
        (else #f)))
    music))

% Change text contents for voice one or voice two
#(define (changeText grob ctx c voice symbol)
  (if (and (string=? (ly:context-id ctx) voice)
           (string=? (ly:grob-property grob 'text) ""))
    (ly:grob-set-property!
      grob
      'text
      (markup (#:bold (ly:context-property ctx symbol))))))

solo =
#(define-music-function (music) (ly:music?)
  #{
    \applyOutput Voice.TextScript #(lambda (grob ctx c) (changeText grob ctx c "one" 'soloText))
    \addText #music
  #} )

soloII =
#(define-music-function (music) (ly:music?)
  #{
    \applyOutput Voice.TextScript #(lambda (grob ctx c) (changeText grob ctx c "two" 'soloIIText))
    \addText #music
  #} )

noADue = \once \set aDueText = \markup \null

% Example
%{
\new Staff \with { soloText="ObI" soloIIText="ObII" } <<
  \partcombine
  {
    \noADue c''1
    \partcombineApart R1 \solo <c'' e''>2 c''2
    \partcombineAutomatic c''1
  }
  {
    c''1
    \soloII c'2 d'2 R1
    c''1
  }
>>

\layout {
  \context {
    \Staff
    instrumentName = "Oboes"
  }
}
%}
